//#include "RB_were_here.h"

#define EMST_DISABLE
#include <RB_EmuStats.h>
#define EMST_CPU    0
#define EMST_Z80    1
#define EMST_TIM    2
#define EMST_VRAM   3
#define EMST_PAD    4
#define EMST_SCAN   5

extern unsigned char sound_enable, z80_enable;
extern unsigned int frame;

#define SWAP_W2W(v16)  (((v16 & 0xFF) << 8) | ((v16 & 0xFF00) >> 8) )
#define SWAP_L2L(v32)  (((v32 & 0xFF) << 24) | ((v32 & 0xFF00) << 8) | ((v32 & 0xFF0000) >> 8) | ((v32 & 0xFF000000) >> 24))


// given a byte pointer, it reads out 4(2) bytes and swappes them
#define SWAP_BPTR2L(ptr)   (((_u32)*(ptr)) | (((_u32)*(ptr+1)) << 8) | (((_u32)*(ptr+2)) << 16) | (((_u32)*(ptr+3)) << 24))
#define SWAP_BPTR2W(ptr)   (((_u16)*(ptr)) | (((_u16)*(ptr+1)) << 8))

#define SWAP_W2BPTR(ptr, data)  *(ptr)   =  0x00FF & data;\
                                *(ptr+1) = (0xFF00 & data) >> 8;
                                
#define SWAP_L2BPTR(ptr, data)  *(ptr)   =  0x000000FF & data;\
                                *(ptr+1) = (0x0000FF00 & data) >> 8;\
                                *(ptr+2) = (0x00FF0000 & data) >> 16;\
                                *(ptr+3) = (0xFF000000 & data) >> 24;
                                
        
#define PORTING_SATURN
//#define PORTING_ROM_INCLUDED

// the NeoGeo rom file seems to be in LSB format
#define PORTING_MSB_ALL
//#define PORTING_MSB_NEC     // only necessary stuff
//#define PORTING_MSB_PRE     // preprocess rom
//#define PORTING_LSB

/* !!! frameskip handling of NeoPop is shit:
 * 1.  gfx is drawn when frameskip_count == 0,
 *     but the next system_VBL() got frameskip_count == 1
 * 2.  frameskip_count is updated using %, this can involve
 *     division plus subtraction!
 * 3.  if system_frameskip_key = 0, an error occurs: division by 0!    
 */
#define PORTING_FRAMESKIP_FIX

// byte offsets in a long word
#ifdef PORTING_MSB_ALL
    // MSB first
        // read: byte i of n bytes
#define PORTING_B0_OF_4B      3
#define PORTING_B1_OF_4B      2
#define PORTING_B2_OF_4B      1
#define PORTING_B3_OF_4B      0
        // read: word i of n bytes
//#define PORTING_W0_OF_4B      2
//#define PORTING_W1_OF_4B      0

#define PORTING_W0_OF_4B      2
#define PORTING_W1_OF_4B      0
#else
    // LSB first
        // read: byte i of n bytes
#define PORTING_B0_OF_4B      0
#define PORTING_B1_OF_4B      1
#define PORTING_B2_OF_4B      2
#define PORTING_B3_OF_4B      3
        // read: word i of n bytes
#define PORTING_W0_OF_4B      0
#define PORTING_W1_OF_4B      2

#endif

#ifdef PORTING_ROM_INCLUDED
extern char gamedata[];
extern int gamedata_size;
#endif

